﻿//*****************************************************************************
//
//  ColorComboBox140.h
//
//*****************************************************************************

// これはMFCのCComboBoxクラスから派生したCColorComboBoxクラスを定義します。
// ■CWnd
// └■CComboBox
// 　└■CColorComboBox
// これはMicrosoft Visual C++ 2015 Community Editionで作られています。
// このライブラリは、GNU 劣等一般公衆利用許諾契約書(LGPL)に基づき配布されます。
// プロジェクトホームページ：http://www5a.biglobe.ne.jp/~kuzunet/ 

// This library is free software; you can redistribute it and/or 
// modify it under the terms of the GNU Lesser General Public 
// License as published by the Free Software Foundation; either 
// version 2.1 of the License, or (at your option) any later version. 

// This library is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
// Lesser General Public License for more details. 

// You should have received a copy of the GNU Lesser General Public 
// License along with this library; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 


#ifndef _COLORCOMBOBOX_H_
#define _COLORCOMBOBOX_H_

#define COLORCOMBOBOX_BLACK       (RGB (0, 0, 0))
#define COLORCOMBOBOX_DARKRED     (RGB (128, 0, 0))
#define COLORCOMBOBOX_DARKGREEN   (RGB (0, 128, 0))
#define COLORCOMBOBOX_DARKYELLOW  (RGB (128, 128, 0))
#define COLORCOMBOBOX_DARKBLUE    (RGB (0, 0, 128))
#define COLORCOMBOBOX_DARKMAGENTA (RGB (128, 0, 128))
#define COLORCOMBOBOX_DARKCYAN    (RGB (0, 128, 128))
#define COLORCOMBOBOX_DARKGRAY    (RGB (128, 128, 128))
#define COLORCOMBOBOX_GRAY        (RGB (192, 192, 192))
#define COLORCOMBOBOX_RED         (RGB (255, 0, 0))
#define COLORCOMBOBOX_GREEN       (RGB (0, 255, 0))
#define COLORCOMBOBOX_YELLOW      (RGB (255, 255, 0)
#define COLORCOMBOBOX_BLUE        (RGB (0, 0, 255))
#define COLORCOMBOBOX_MAGENTA     (RGB (255, 0, 255))
#define COLORCOMBOBOX_CYAN        (RGB (0, 255, 255))
#define COLORCOMBOBOX_WHITE       (RGB (255, 255, 255))
#define COLORCOMBOBOX_OTHER       0xFFFFFFFF

class AFX_EXT_CLASS CColorComboBox : public CComboBox {

	DECLARE_DYNCREATE (CColorComboBox)

protected:
	// アトリビュート
	COLORREF m_clrCurColor;
protected:
	// オーバーライド
	virtual BOOL PreCreateWindow (CREATESTRUCT&);
	virtual void MeasureItem (LPMEASUREITEMSTRUCT);
	virtual void DrawItem (LPDRAWITEMSTRUCT);
public:
	// オペレーション
	BOOL SetCurColor (COLORREF clr);
	COLORREF GetCurColor () const { return m_clrCurColor; }
	void CColorComboBox::ClearSampleColor ();
	int CColorComboBox::AddSampleColor (COLORREF clr);
	COLORREF CColorComboBox::GetSampleColor (int nIndex) const;
	int CColorComboBox::SetSampleColor (int nIndex, COLORREF clr);
	
	// メッセージマップ
protected:
	afx_msg void OnSelChange ();
	DECLARE_MESSAGE_MAP ()
};

#endif
